#include "global.h"
#include "texturemanager.h"
#include "textureobject.h"

CTextureMManager* Textures::TextureManager = NULL;

extern void Textures::InitTextureManager()
{
	if( !TextureManager )TextureManager = new CTextureMManager;
};

extern void Textures::DoneTextureManager()
{
	SAFE_DELETE( TextureManager );
};

extern CTextureMManager* Textures::GetTextureManager()
{
	return TextureManager;
};

CMMTexture* CTextureMManager::CreateTextureObject( TextureTypes TYPE )
{
	CMMTexture* Obj = NULL;

	switch( TYPE )
	{
		case TEXTURE_SIMPLE:
			Obj = new CMMTexture;
			break;
		default:
			Obj = NULL;
	};
	if( Obj ) ObjList.push_back( Obj );
	return Obj;
};

CMMTexture* CTextureMManager::FindTexture( LPWSTR FILENAME )
{
	CMMTexture* Obj = NULL;
	for( MMObjIter i = ObjList.begin(); i != ObjList.end(); ++i )
	{
		Obj = (CMMTexture*)( *i );
		if( Obj->GetTextureFileName() == FILENAME ) return (CMMTexture*)Obj->GetObject();
	};
	return NULL;
};